#ifndef section_six_solutions
#define section_six_solutions

struct TreeNode {
    int data;
    TreeNode* left;
    TreeNode* right;

    TreeNode(int data, TreeNode* left, TreeNode* right) {
        this->data = data;
        this->left = left;
        this->right = right;
    }

    TreeNode(int data) {
        this->data = data;
        this->left = nullptr;
        this->right = nullptr;
    }
};

struct TreeNodeChar {
    char data;
    TreeNodeChar* left;
    TreeNodeChar* right;

    TreeNodeChar(char data, TreeNodeChar* left, TreeNodeChar* right) {
        this->data = data;
        this->left = left;
        this->right = right;
    }

    TreeNodeChar(char data) {
        this->data = data;
        this->left = nullptr;
        this->right = nullptr;
    }
};

struct TreeNodeString {
    std::string data;
    TreeNodeString* left;
    TreeNodeString* right;

    TreeNodeString(std::string data, TreeNodeString* left, TreeNodeString* right) {
        this->data = data;
        this->left = left;
        this->right = right;
    }

    TreeNodeString(std::string data) {
        this->data = data;
        this->left = nullptr;
        this->right = nullptr;
    }
};


/*
 * Function to visualize a tree rooted at the provided node.
 * The tree is printed 90 degrees to the left, so right nodes are towards
 * the top, and left nodes are towards the bottom of the console window.
 */
template <typename NodeType>
void printSidewaysHelper(NodeType* node, std::string indent) {
    if (node) {
        printSidewaysHelper<NodeType>(node->right, indent + "    ");
        std::cout << indent;
        std::cout << node->data;
        std::cout << std::endl;
        printSidewaysHelper<NodeType>(node->left, indent + "    ");
    }
}

template <typename NodeType>
void printSideways(NodeType* node, std::string indent = "") {
    if (node == nullptr) {
        std::cout << "(empty tree)" << std::endl;
    } else {
        std::cout << std::endl << "(right)" << std::endl;
        printSidewaysHelper<NodeType>(node, indent);
        std::cout << "(left)" << std::endl << std::endl;
    }
}

#endif
